# set xrange [8:8388608]
# set xlabel "buffersize [bytes]" 
# set xrange [1:512]
# set logscale x 2
set xlabel "number of MPI processes"
set nologscale y  
set ylabel "bandwidth [Mb/s]" 
set title -10,-3.2
plot '< grep " $LNG By .... PEs dflt" $INP' using 3:6 title "vendor"                           with linespoints lt 8 pt 5 ps 1.6 \
   , '< grep " $LNG By .... PEs tree" $INP' using 3:6 title "binary tree"                      with linespoints lt 9 pt 4 ps 1.6 \
   , '< grep " $LNG By .... PEs pair" $INP' using 3:6 title "pairwise + ring"                  with linespoints lt 3 pt 1 ps 1.6 \
   , '< grep " $LNG By .... PEs half" $INP' using 3:6 title "halving + doubling"               with linespoints lt 4 pt 2 ps 1.6 \
   , '< grep " $LNG By .... PEs blck" $INP' using 3:6 title "binary blocks halving + doubling" with linespoints lt 2 pt 6 ps 1.6 \
   , '< grep " $LNG By .... PEs rdbl" $INP' using 3:6 title "recursive doubling"               with linespoints lt 5 pt 8 ps 1.6 \
   , '< grep " $LNG By .... PEs best" $INP' using 3:6 title "chosen best"                      with linespoints lt 7 pt 7 ps 1.6 

# lt n = colour         |   pt m = sign
#-----------------------|----------------------------
# lt 1 = red            |   pt 1 = plus
# lt 2 = green          |   pt 2 = 2 line cross
# lt 3 = blue           |   pt 3 = 3 line cross
# lt 4 = purple         |   pt 4 = hollow rectangle
# lt 5 = sky blue       |   pt 5 = filled rectangle
# lt 6 = yellow         |   pt 6 = hollow circle
# lt 7 = black          |   pt 7 = filled circle
# lt 8 = orange         |   pt 8 = hollow triangle up
# lt 9 = gray           |   pt 9 = filled triangle up
# lt 10= red            |   pt 10= hollow triangle down
# lt 11= green          |   pt 11= filled triangle down
# lt 12= blue           |   pt 12= hollow rhombus 
# lt 13= purple         |   pt 13= filled rhombus 
