# set xrange [8:8388608]
# set xlabel "buffersize [bytes]" 
# set xrange [1:512]
# set logscale x 2 
set xlabel "number of MPI processes"
set nologscale y  
set ylabel "bandwidth [Mb/s]" 
set title -10,-3.2
plot '< grep " $LNG By .... PEs dflt" $INP' using 3:6 title "vendor"                           with linespoints lt 8 pt 5 ps 1.6 \
   , '< grep " $LNG By .... PEs tree" $INP' using 3:6 title "binary tree"                      with linespoints lt 9 pt 4 ps 1.6 \
   , '< grep " $LNG By .... PEs pair" $INP' using 3:6 title "pairwise + ring"                  with linespoints lt 3 pt 1 ps 1.6 \
   , '< grep " $LNG By .... PEs half" $INP' using 3:6 title "halving + doubling"               with linespoints lt 4 pt 2 ps 1.6 \
   , '< grep " $LNG By .... PEs blck" $INP' using 3:6 title "binary blocks halving + doubling" with linespoints lt 2 pt 6 ps 1.6 \
   , '< grep " $LNG By .... PEs best" $INP' using 3:6 title "chosen best"                      with linespoints lt 7 pt 7 ps 1.6 
