BEGIN{ 
  load_bal_treshold = 1.0; # MPI calls with more than load_bal_treshold sec are sorted out 
  LAST_ID = "_";
  sum_all  = 0.0; sum_mpi  = 0.0;
  sum_all1 = 0.0; sum_mpi1 = 0.0;
  sum_all2 = 0.0; sum_mpi2 = 0.0;
  sum_ally = 0.0; sum_mpiy = 0.0;
  sum_wall_clock = 0.0; sum_size = 0.0; 

  for (size=1; size<=540; size++) sum_time[size]=0.0; 
 
  i_jobs=0;  i_rjobs=0; i_ajobs=0; 
  i_r0x_c=0; i_r0x_l=0; i_r0x_t=0; i_r0x_e=0; i_r0x_o=0; 
  i_r1w_c=0; i_r1w_l=0; i_r1w_t=0; i_r1w_e=0; i_r1w_o=0; 
  i_r1x_c=0; i_r1x_l=0; i_r1x_t=0; i_r1x_e=0; i_r1x_o=0; 
  i_r2w_c=0; i_r2w_l=0; i_r2w_t=0; i_r2w_e=0; i_r2w_o=0; 
  i_r2x_c=0; i_r2x_l=0; i_r2x_t=0; i_r2x_e=0; i_r2x_o=0; 
  i_a0x_c=0; i_a0x_l=0; i_a0x_t=0; i_a0x_e=0; i_a0x_o=0; 
  i_a1w_c=0; i_a1w_l=0; i_a1w_t=0; i_a1w_e=0; i_a1w_o=0; 
  i_a1x_c=0; i_a1x_l=0; i_a1x_t=0; i_a1x_e=0; i_a1x_o=0; 
  i_a2w_c=0; i_a2w_l=0; i_a2w_t=0; i_a2w_e=0; i_a2w_o=0; 
  i_a2x_c=0; i_a2x_l=0; i_a2x_t=0; i_a2x_e=0; i_a2x_o=0; 
 
  i_rlX1_c=0; i_rlX1_l=0; i_rlX1_t=0; i_rlX1_e=0; i_rlX1_o=0; 
  i_rlX2_c=0; i_rlX2_l=0; i_rlX2_t=0; i_rlX2_e=0; i_rlX2_o=0; 
 
  j_jobs=0;  j_rjobs=0; j_ajobs=0; 
  j_r0x_c=0; j_r0x_l=0; j_r0x_t=0; j_r0x_e=0; j_r0x_o=0; 
  j_r1w_c=0; j_r1w_l=0; j_r1w_t=0; j_r1w_e=0; j_r1w_o=0; 
  j_r1x_c=0; j_r1x_l=0; j_r1x_t=0; j_r1x_e=0; j_r1x_o=0; 
  j_r2w_c=0; j_r2w_l=0; j_r2w_t=0; j_r2w_e=0; j_r2w_o=0; 
  j_r2x_c=0; j_r2x_l=0; j_r2x_t=0; j_r2x_e=0; j_r2x_o=0; 
  j_a0x_c=0; j_a0x_l=0; j_a0x_t=0; j_a0x_e=0; j_a0x_o=0; 
  j_a1w_c=0; j_a1w_l=0; j_a1w_t=0; j_a1w_e=0; j_a1w_o=0; 
  j_a1x_c=0; j_a1x_l=0; j_a1x_t=0; j_a1x_e=0; j_a1x_o=0; 
  j_a2w_c=0; j_a2w_l=0; j_a2w_t=0; j_a2w_e=0; j_a2w_o=0; 
  j_a2x_c=0; j_a2x_l=0; j_a2x_t=0; j_a2x_e=0; j_a2x_o=0; 
 
  j_rlX1_c=0; j_rlX1_l=0; j_rlX1_t=0; j_rlX1_e=0; j_rlX1_o=0; 
  j_rlX2_c=0; j_rlX2_l=0; j_rlX2_t=0; j_rlX2_e=0; j_rlX2_o=0; 
 
  t_jobs=0;  t_rjobs=0; t_ajobs=0; 
  t_r0x_c=0; t_r0x_l=0; t_r0x_t=0; t_r0x_e=0; t_r0x_o=0; 
  t_r1w_c=0; t_r1w_l=0; t_r1w_t=0; t_r1w_e=0; t_r1w_o=0; 
  t_r1x_c=0; t_r1x_l=0; t_r1x_t=0; t_r1x_e=0; t_r1x_o=0; 
  t_r2w_c=0; t_r2w_l=0; t_r2w_t=0; t_r2w_e=0; t_r2w_o=0; 
  t_r2x_c=0; t_r2x_l=0; t_r2x_t=0; t_r2x_e=0; t_r2x_o=0; 
  t_a0t_c=0; t_a0t_l=0; t_a0t_t=0; t_a0t_e=0; t_a0t_o=0; 
  t_a1w_c=0; t_a1w_l=0; t_a1w_t=0; t_a1w_e=0; t_a1w_o=0; 
  t_a1t_c=0; t_a1t_l=0; t_a1t_t=0; t_a1t_e=0; t_a1t_o=0; 
  t_a2w_c=0; t_a2w_l=0; t_a2w_t=0; t_a2w_e=0; t_a2w_o=0; 
  t_a2t_c=0; t_a2t_l=0; t_a2t_t=0; t_a2t_e=0; t_a2t_o=0; 
 
  t_rlB_c=0; t_rlB_l=0; t_rlB_t=0; t_rlB_e=0; t_rlB_o=0; 
  t_rlA_c=0; t_rlA_l=0; t_rlA_t=0; t_rlA_e=0; t_rlA_o=0; 
  t_rl0_c=0; t_rl0_l=0; t_rl0_t=0; t_rl0_e=0; t_rl0_o=0; 
  t_rl1_c=0; t_rl1_l=0; t_rl1_t=0; t_rl1_e=0; t_rl1_o=0; 
  t_rl2_c=0; t_rl2_l=0; t_rl2_t=0; t_rl2_e=0; t_rl2_o=0; 
  t_rl3_c=0; t_rl3_l=0; t_rl3_t=0; t_rl3_e=0; t_rl3_o=0; 
  t_rl4_c=0; t_rl4_l=0; t_rl4_t=0; t_rl4_e=0; t_rl4_o=0; 
  t_rl5_c=0; t_rl5_l=0; t_rl5_t=0; t_rl5_e=0; t_rl5_o=0; 
  t_rl6_c=0; t_rl6_l=0; t_rl6_t=0; t_rl6_e=0; t_rl6_o=0; 
  t_rl7_c=0; t_rl7_l=0; t_rl7_t=0; t_rl7_e=0; t_rl7_o=0; 
  t_rl8_c=0; t_rl8_l=0; t_rl8_t=0; t_rl8_e=0; t_rl8_o=0; 
  t_rl9_c=0; t_rl9_l=0; t_rl9_t=0; t_rl9_e=0; t_rl9_o=0; 
  t_rl10_c=0; t_rl10_l=0; t_rl10_t=0; t_rl10_e=0; t_rl10_o=0; 
 
  t_rlX1_c=0; t_rlX1_l=0; t_rlX1_t=0; t_rlX1_e=0; t_rlX1_o=0; 
  t_rlX2_c=0; t_rlX2_l=0; t_rlX2_t=0; t_rlX2_e=0; t_rlX2_o=0; 
 
  t_alB_c=0; t_alB_l=0; t_alB_t=0; t_alB_e=0; t_alB_o=0; 
  t_alA_c=0; t_alA_l=0; t_alA_t=0; t_alA_e=0; t_alA_o=0; 
  t_al0_c=0; t_al0_l=0; t_al0_t=0; t_al0_e=0; t_al0_o=0; 
  t_al1_c=0; t_al1_l=0; t_al1_t=0; t_al1_e=0; t_al1_o=0; 
  t_al2_c=0; t_al2_l=0; t_al2_t=0; t_al2_e=0; t_al2_o=0; 
  t_al3_c=0; t_al3_l=0; t_al3_t=0; t_al3_e=0; t_al3_o=0; 
  t_al4_c=0; t_al4_l=0; t_al4_t=0; t_al4_e=0; t_al4_o=0; 
  t_al5_c=0; t_al5_l=0; t_al5_t=0; t_al5_e=0; t_al5_o=0; 
  t_al6_c=0; t_al6_l=0; t_al6_t=0; t_al6_e=0; t_al6_o=0; 
  t_al7_c=0; t_al7_l=0; t_al7_t=0; t_al7_e=0; t_al7_o=0; 
  t_al8_c=0; t_al8_l=0; t_al8_t=0; t_al8_e=0; t_al8_o=0; 
  t_al9_c=0; t_al9_l=0; t_al9_t=0; t_al9_e=0; t_al9_o=0; 
  t_al10_c=0; t_al10_l=0; t_al10_t=0; t_al10_e=0; t_al10_o=0; 
 
  t_alX1_c=0; t_alX1_l=0; t_alX1_t=0; t_alX1_e=0; t_alX1_o=0; 
  t_alX2_c=0; t_alX2_l=0; t_alX2_t=0; t_alX2_e=0; t_alX2_o=0; 

  t_r_calls=0; t_r_lng=0; t_r_time=0; t_r_estim=0; t_r_optim=0;
  t_a_calls=0; t_a_lng=0; t_a_time=0; t_a_estim=0; t_a_optim=0
} 
{ if ($2==1)
  { LAST = $1;
    size = $4; 
    r_calls=0; a_calls=0; 
  }
  else 
    if ($1 == LAST)
    {
      if (($2==299) && ($7>0))
      {
        r_cnt=$7*size; r_lng=$9*size; r_calls=$4*size; r_time=$5*size;
 
        if      (size <=   2 ) { lat=0.013e-3; bw= 56.48e+6; }
        else if (size <=   4 ) { lat=0.025e-3; bw= 32.68e+6; }
        else if (size <=   8 ) { lat=0.036e-3; bw= 27.94e+6; }
        else if (size <=  16 ) { lat=0.047e-3; bw= 20.33e+6; }
        else if (size <=  32 ) { lat=0.058e-3; bw= 17.19e+6; }
        else if (size <=  64 ) { lat=0.068e-3; bw= 14.09e+6; }
        else if (size <= 128 ) { lat=0.078e-3; bw= 12.46e+6; }
        else                   { lat=0.090e-3; bw= 10.67e+6; }
 
        r_estim = r_calls * lat + r_lng / bw;
 
        if (r_calls > 0)
        { 
          lng_call = r_lng / r_calls;
          if      (lng_call <=      64.9) fact=1.0;
          else if (lng_call <=    2048.9) fact=1.1; 
          else if (lng_call <=   16384.9) fact=1.0; 
          else if (lng_call <=  262144.9) fact=1.1; 
          else                            fact=1.0; 
          r_estim = r_estim * fact;
        } 

        if      (size <=   2 ) { lat=0.009e-3; bw=132.64e+6; }
        else if (size <=   4 ) { lat=0.014e-3; bw= 88.16e+6; }
        else if (size <=   8 ) { lat=0.018e-3; bw= 72.25e+6; }
        else if (size <=  16 ) { lat=0.022e-3; bw= 66.25e+6; }
        else if (size <=  32 ) { lat=0.029e-3; bw= 62.68e+6; }
        else if (size <=  64 ) { lat=0.031e-3; bw= 60.98e+6; }
        else if (size <= 128 ) { lat=0.036e-3; bw= 60.31e+6; }
        else                   { lat=0.075e-3; bw= 59.18e+6; }
 
        r_optim = r_calls * lat + r_lng / bw;
 
        if (r_calls > 0)
        { 
          lng_call = r_lng / r_calls;
          if      (lng_call <=      32.9) fact=1.0;
          else if (lng_call <=     256.9) fact=2.2; 
          else if (lng_call <=    1024.9) fact=2.7; 
          else if (lng_call <=    4096.9) fact=2.8; 
          else if (lng_call <=   16384.9) fact=1.7; 
          else if (lng_call <=   65536.9) fact=1.3; 
          else if (lng_call <=  262144.9) fact=1.1; 
          else                            fact=1.0; 
          r_optim = r_optim * fact;
        } 
      }
      if (($2==307) && ($7>0))
      {
        a_cnt=$7*size; a_lng=$9*size; a_calls=$4*size; a_time=$5*size;
 
        if      (size <=   2 ) { lat=0.015e-3; bw= 45.33e+6; }
        else if (size <=   4 ) { lat=0.024e-3; bw= 28.43e+6; }
        else if (size <=   8 ) { lat=0.033e-3; bw= 20.25e+6; }
        else if (size <=  16 ) { lat=0.043e-3; bw= 15.94e+6; }
        else if (size <=  32 ) { lat=0.053e-3; bw= 12.79e+6; }
        else if (size <=  64 ) { lat=0.063e-3; bw= 10.90e+6; }
        else if (size <= 128 ) { lat=0.075e-3; bw=  9.06e+6; }
        else                   { lat=0.087e-3; bw=  7.67e+6; }
 
        a_estim = a_calls * lat + a_lng / bw;
 
        if (a_calls > 0)
        { 
          lng_call = a_lng / a_calls;
          if      (lng_call <=      32.9) fact=1.0;
          else if (lng_call <=   65536.9) fact=1.1; 
          else                            fact=1.0; 
          a_estim = a_estim * fact;
        } 

        if      (size <=   2 ) { lat=0.018e-3; bw=132.02e+6; }
        else if (size <=   4 ) { lat=0.028e-3; bw= 79.48e+6; }
        else if (size <=   8 ) { lat=0.037e-3; bw= 61.39e+6; }
        else if (size <=  16 ) { lat=0.047e-3; bw= 56.28e+6; }
        else if (size <=  32 ) { lat=0.058e-3; bw= 52.84e+6; }
        else if (size <=  64 ) { lat=0.068e-3; bw= 50.76e+6; }
        else if (size <= 128 ) { lat=0.080e-3; bw= 50.20e+6; }
        else                   { lat=0.090e-3; bw= 49.68e+6; }
 
        a_optim = a_calls * lat + a_lng / bw;
 
        if (a_calls > 0)
        { 
          lng_call = a_lng / a_calls;
          if      (lng_call <=      32.9) fact=1.0;
          else if (lng_call <=     256.9) fact=1.2; 
          else if (lng_call <=    1024.9) fact=1.5; 
          else if (lng_call <=    4096.9) fact=2.0; 
          else if (lng_call <=   16384.9) fact=1.5; 
          else if (lng_call <=   65536.9) fact=1.2; 
          else if (lng_call <=  262144.9) fact=1.1; 
          else                            fact=1.0; 
          a_optim = a_optim * fact;
        } 
      }
      if ($2==991)
      {
        if (($6 > 0) && ($6/3600 <= 12.1))
        {
          sum_ally = sum_ally + $6*size;
          sum_mpiy = sum_mpiy + $4*size;
        }
      }
      if ($2==993)
      {
        if (($6 <= 0) || ($6/3600/size > 12.1))
        {
          printf(" entry with %11.2e hours (size=%4d, total time=%11.2e) ignored\n", $6/3600/size, size, $6); 
        } 
        else 
        {
          if (size==2 || size==4 || size==8 || size==16 || size==32 || size==64 || size==128 || size==256 || size==512)
          {
            i_jobs++; 
            sum_all1 = sum_all1 + $6;
            sum_mpi1 = sum_mpi1 + $4;
            if (r_calls > 0)
            { 
              i_rjobs++; 
              datalng = r_lng / r_cnt;
              if      (datalng <  6) {i_r0x_c=i_r0x_c+r_calls; i_r0x_l=i_r0x_l+r_lng; i_r0x_t=i_r0x_t+r_time; i_r0x_e=i_r0x_e+r_estim; i_r0x_o=i_r0x_o+r_optim; }
              else if (datalng <  9) {i_r1w_c=i_r1w_c+r_calls; i_r1w_l=i_r1w_l+r_lng; i_r1w_t=i_r1w_t+r_time; i_r1w_e=i_r1w_e+r_estim; i_r1w_o=i_r1w_o+r_optim; }
              else if (datalng < 15) {i_r1x_c=i_r1x_c+r_calls; i_r1x_l=i_r1x_l+r_lng; i_r1x_t=i_r1x_t+r_time; i_r1x_e=i_r1x_e+r_estim; i_r1x_o=i_r1x_o+r_optim; }
              else if (datalng < 18) {i_r2w_c=i_r2w_c+r_calls; i_r2w_l=i_r2w_l+r_lng; i_r2w_t=i_r2w_t+r_time; i_r2w_e=i_r2w_e+r_estim; i_r2w_o=i_r2w_o+r_optim; }
              else                   {i_r2x_c=i_r2x_c+r_calls; i_r2x_l=i_r2x_l+r_lng; i_r2x_t=i_r2x_t+r_time; i_r2x_e=i_r2x_e+r_estim; i_r2x_o=i_r2x_o+r_optim; }
 
              if (r_lng/r_calls <=    2048.5) {i_rlX1_c=i_rlX1_c+r_calls; i_rlX1_l=i_rlX1_l+r_lng; i_rlX1_t=i_rlX1_t+r_time; i_rlX1_e=i_rlX1_e+r_estim; i_rlX1_o=i_rlX1_o+r_optim; } 
              else                            {i_rlX2_c=i_rlX2_c+r_calls; i_rlX2_l=i_rlX2_l+r_lng; i_rlX2_t=i_rlX2_t+r_time; i_rlX2_e=i_rlX2_e+r_estim; i_rlX2_o=i_rlX2_o+r_optim; } 
            } 
            if (a_calls > 0)
            { 
              i_ajobs++; 
              datalng = a_lng / a_cnt;
              if      (datalng <  6) {i_a0x_c=i_a0x_c+a_calls; i_a0x_l=i_a0x_l+a_lng; i_a0x_t=i_a0x_t+a_time; i_a0x_e=i_a0x_e+a_estim; i_a0x_o=i_a0x_o+a_optim; }
              else if (datalng <  9) {i_a1w_c=i_a1w_c+a_calls; i_a1w_l=i_a1w_l+a_lng; i_a1w_t=i_a1w_t+a_time; i_a1w_e=i_a1w_e+a_estim; i_a1w_o=i_a1w_o+a_optim; }
              else if (datalng < 15) {i_a1x_c=i_a1x_c+a_calls; i_a1x_l=i_a1x_l+a_lng; i_a1x_t=i_a1x_t+a_time; i_a1x_e=i_a1x_e+a_estim; i_a1x_o=i_a1x_o+a_optim; }
              else if (datalng < 18) {i_a2w_c=i_a2w_c+a_calls; i_a2w_l=i_a2w_l+a_lng; i_a2w_t=i_a2w_t+a_time; i_a2w_e=i_a2w_e+a_estim; i_a2w_o=i_a2w_o+a_optim; }
              else                   {i_a2x_c=i_a2x_c+a_calls; i_a2x_l=i_a2x_l+a_lng; i_a2x_t=i_a2x_t+a_time; i_a2x_e=i_a2x_e+a_estim; i_a2x_o=i_a2x_o+a_optim; }
 
              if (a_lng/a_calls <=    2048.5) {i_alX1_c=i_alX1_c+a_calls; i_alX1_l=i_alX1_l+a_lng; i_alX1_t=i_alX1_t+a_time; i_alX1_e=i_alX1_e+a_estim; i_alX1_o=i_alX1_o+a_optim; } 
              else                            {i_alX2_c=i_alX2_c+a_calls; i_alX2_l=i_alX2_l+a_lng; i_alX2_t=i_alX2_t+a_time; i_alX2_e=i_alX2_e+a_estim; i_alX2_o=i_alX2_o+a_optim; } 
            } 
          }
          else 
          {
            j_jobs++; 
            sum_all2 = sum_all2 + $6;
            sum_mpi2 = sum_mpi2 + $4;
            if (r_calls > 0)
            { 
              j_rjobs++; 
              datalng = r_lng / r_cnt;
              if      (datalng <  6) {j_r0x_c=j_r0x_c+r_calls; j_r0x_l=j_r0x_l+r_lng; j_r0x_t=j_r0x_t+r_time; j_r0x_e=j_r0x_e+r_estim; j_r0x_o=j_r0x_o+r_optim; }
              else if (datalng <  9) {j_r1w_c=j_r1w_c+r_calls; j_r1w_l=j_r1w_l+r_lng; j_r1w_t=j_r1w_t+r_time; j_r1w_e=j_r1w_e+r_estim; j_r1w_o=j_r1w_o+r_optim; }
              else if (datalng < 15) {j_r1x_c=j_r1x_c+r_calls; j_r1x_l=j_r1x_l+r_lng; j_r1x_t=j_r1x_t+r_time; j_r1x_e=j_r1x_e+r_estim; j_r1x_o=j_r1x_o+r_optim; }
              else if (datalng < 18) {j_r2w_c=j_r2w_c+r_calls; j_r2w_l=j_r2w_l+r_lng; j_r2w_t=j_r2w_t+r_time; j_r2w_e=j_r2w_e+r_estim; j_r2w_o=j_r2w_o+r_optim; }
              else                   {j_r2x_c=j_r2x_c+r_calls; j_r2x_l=j_r2x_l+r_lng; j_r2x_t=j_r2x_t+r_time; j_r2x_e=j_r2x_e+r_estim; j_r2x_o=j_r2x_o+r_optim; }
 
              if (r_lng/r_calls <=    2048.5) {j_rlX1_c=j_rlX1_c+r_calls; j_rlX1_l=j_rlX1_l+r_lng; j_rlX1_t=j_rlX1_t+r_time; j_rlX1_e=j_rlX1_e+r_estim; j_rlX1_o=j_rlX1_o+r_optim; } 
              else                            {j_rlX2_c=j_rlX2_c+r_calls; j_rlX2_l=j_rlX2_l+r_lng; j_rlX2_t=j_rlX2_t+r_time; j_rlX2_e=j_rlX2_e+r_estim; j_rlX2_o=j_rlX2_o+r_optim; } 
            } 
            if (a_calls > 0)
            { 
              j_ajobs++; 
              datalng = a_lng / a_cnt;
              if      (datalng <  6) {j_a0x_c=j_a0x_c+a_calls; j_a0x_l=j_a0x_l+a_lng; j_a0x_t=j_a0x_t+a_time; j_a0x_e=j_a0x_e+a_estim; j_a0x_o=j_a0x_o+a_optim; }
              else if (datalng <  9) {j_a1w_c=j_a1w_c+a_calls; j_a1w_l=j_a1w_l+a_lng; j_a1w_t=j_a1w_t+a_time; j_a1w_e=j_a1w_e+a_estim; j_a1w_o=j_a1w_o+a_optim; }
              else if (datalng < 15) {j_a1x_c=j_a1x_c+a_calls; j_a1x_l=j_a1x_l+a_lng; j_a1x_t=j_a1x_t+a_time; j_a1x_e=j_a1x_e+a_estim; j_a1x_o=j_a1x_o+a_optim; }
              else if (datalng < 18) {j_a2w_c=j_a2w_c+a_calls; j_a2w_l=j_a2w_l+a_lng; j_a2w_t=j_a2w_t+a_time; j_a2w_e=j_a2w_e+a_estim; j_a2w_o=j_a2w_o+a_optim; }
              else                   {j_a2x_c=j_a2x_c+a_calls; j_a2x_l=j_a2x_l+a_lng; j_a2x_t=j_a2x_t+a_time; j_a2x_e=j_a2x_e+a_estim; j_a2x_o=j_a2x_o+a_optim; }
 
              if (a_lng/a_calls <=    2048.5) {j_alX1_c=j_alX1_c+a_calls; j_alX1_l=j_alX1_l+a_lng; j_alX1_t=j_alX1_t+a_time; j_alX1_e=j_alX1_e+a_estim; j_alX1_o=j_alX1_o+a_optim; } 
              else                            {j_alX2_c=j_alX2_c+a_calls; j_alX2_l=j_alX2_l+a_lng; j_alX2_t=j_alX2_t+a_time; j_alX2_e=j_alX2_e+a_estim; j_alX2_o=j_alX2_o+a_optim; } 
            } 
          } 
          { # total = category I and II
            t_jobs++; 
            sum_all = sum_all + $6;
            sum_mpi = sum_mpi + $4;
            sum_time[size]=sum_time[size] + $6; 
            sum_size = sum_size + size; sum_wall_clock = sum_wall_clock + $6/size; 
            if (r_calls > 0)
            { 
              t_rjobs++; 
              t_r_calls=t_r_calls+r_calls; t_r_lng=t_r_lng+r_lng; t_r_time=t_r_time+r_time; t_r_estim=t_r_estim+r_estim; t_r_optim=t_r_optim+r_optim;
              datalng = r_lng / r_cnt;
              if      (datalng <  6) {t_r0x_c=t_r0x_c+r_calls; t_r0x_l=t_r0x_l+r_lng; t_r0x_t=t_r0x_t+r_time; t_r0x_e=t_r0x_e+r_estim; t_r0x_o=t_r0x_o+r_optim; }
              else if (datalng <  9) {t_r1w_c=t_r1w_c+r_calls; t_r1w_l=t_r1w_l+r_lng; t_r1w_t=t_r1w_t+r_time; t_r1w_e=t_r1w_e+r_estim; t_r1w_o=t_r1w_o+r_optim; }
              else if (datalng < 15) {t_r1x_c=t_r1x_c+r_calls; t_r1x_l=t_r1x_l+r_lng; t_r1x_t=t_r1x_t+r_time; t_r1x_e=t_r1x_e+r_estim; t_r1x_o=t_r1x_o+r_optim; }
              else if (datalng < 18) {t_r2w_c=t_r2w_c+r_calls; t_r2w_l=t_r2w_l+r_lng; t_r2w_t=t_r2w_t+r_time; t_r2w_e=t_r2w_e+r_estim; t_r2w_o=t_r2w_o+r_optim; }
              else                   {t_r2x_c=t_r2x_c+r_calls; t_r2x_l=t_r2x_l+r_lng; t_r2x_t=t_r2x_t+r_time; t_r2x_e=t_r2x_e+r_estim; t_r2x_o=t_r2x_o+r_optim; }
 
              # exclude badly load balanced calls, i.e., with more thn 4 sec per call
              if (r_time/r_calls > load_bal_treshold) {t_rlB_c=t_rlB_c+r_calls; t_rlB_l=t_rlB_l+r_lng; t_rlB_t=t_rlB_t+r_time; t_rlB_e=t_rlB_e+r_estim; t_rlB_o=t_rlB_o+r_optim; } 
              else if (r_lng/r_calls <=       8.5) {t_rlA_c=t_rlA_c+r_calls; t_rlA_l=t_rlA_l+r_lng; t_rlA_t=t_rlA_t+r_time; t_rlA_e=t_rlA_e+r_estim; t_rlA_o=t_rlA_o+r_optim; } 
              else if (r_lng/r_calls <=      16.5) {t_rl0_c=t_rl0_c+r_calls; t_rl0_l=t_rl0_l+r_lng; t_rl0_t=t_rl0_t+r_time; t_rl0_e=t_rl0_e+r_estim; t_rl0_o=t_rl0_o+r_optim; } 
              else if (r_lng/r_calls <=     128.5) {t_rl1_c=t_rl1_c+r_calls; t_rl1_l=t_rl1_l+r_lng; t_rl1_t=t_rl1_t+r_time; t_rl1_e=t_rl1_e+r_estim; t_rl1_o=t_rl1_o+r_optim; } 
              else if (r_lng/r_calls <=    1024.5) {t_rl2_c=t_rl2_c+r_calls; t_rl2_l=t_rl2_l+r_lng; t_rl2_t=t_rl2_t+r_time; t_rl2_e=t_rl2_e+r_estim; t_rl2_o=t_rl2_o+r_optim; } 
              else if (r_lng/r_calls <=    2048.5) {t_rl3_c=t_rl3_c+r_calls; t_rl3_l=t_rl3_l+r_lng; t_rl3_t=t_rl3_t+r_time; t_rl3_e=t_rl3_e+r_estim; t_rl3_o=t_rl3_o+r_optim; } 
              else if (r_lng/r_calls <=    4096.5) {t_rl4_c=t_rl4_c+r_calls; t_rl4_l=t_rl4_l+r_lng; t_rl4_t=t_rl4_t+r_time; t_rl4_e=t_rl4_e+r_estim; t_rl4_o=t_rl4_o+r_optim; } 
              else if (r_lng/r_calls <=    8192.5) {t_rl5_c=t_rl5_c+r_calls; t_rl5_l=t_rl5_l+r_lng; t_rl5_t=t_rl5_t+r_time; t_rl5_e=t_rl5_e+r_estim; t_rl5_o=t_rl5_o+r_optim; } 
              else if (r_lng/r_calls <=   32768.5) {t_rl6_c=t_rl6_c+r_calls; t_rl6_l=t_rl6_l+r_lng; t_rl6_t=t_rl6_t+r_time; t_rl6_e=t_rl6_e+r_estim; t_rl6_o=t_rl6_o+r_optim; } 
              else if (r_lng/r_calls <=  131072.5) {t_rl7_c=t_rl7_c+r_calls; t_rl7_l=t_rl7_l+r_lng; t_rl7_t=t_rl7_t+r_time; t_rl7_e=t_rl7_e+r_estim; t_rl7_o=t_rl7_o+r_optim; } 
              else if (r_lng/r_calls <=  524288.5) {t_rl8_c=t_rl8_c+r_calls; t_rl8_l=t_rl8_l+r_lng; t_rl8_t=t_rl8_t+r_time; t_rl8_e=t_rl8_e+r_estim; t_rl8_o=t_rl8_o+r_optim; } 
              else if (r_lng/r_calls <= 2097152.5) {t_rl9_c=t_rl9_c+r_calls; t_rl9_l=t_rl9_l+r_lng; t_rl9_t=t_rl9_t+r_time; t_rl9_e=t_rl9_e+r_estim; t_rl9_o=t_rl9_o+r_optim; } 
              else                                 {t_rl10_c=t_rl10_c+r_calls; t_rl10_l=t_rl10_l+r_lng; t_rl10_t=t_rl10_t+r_time; t_rl10_e=t_rl10_e+r_estim; t_rl10_o=t_rl10_o+r_optim; } 
 
              if (r_lng/r_calls <=    2048.5) {t_rlX1_c=t_rlX1_c+r_calls; t_rlX1_l=t_rlX1_l+r_lng; t_rlX1_t=t_rlX1_t+r_time; t_rlX1_e=t_rlX1_e+r_estim; t_rlX1_o=t_rlX1_o+r_optim; } 
              else                            {t_rlX2_c=t_rlX2_c+r_calls; t_rlX2_l=t_rlX2_l+r_lng; t_rlX2_t=t_rlX2_t+r_time; t_rlX2_e=t_rlX2_e+r_estim; t_rlX2_o=t_rlX2_o+r_optim; } 
            } 
            if (a_calls > 0)
            { 
              t_ajobs++; 
              t_a_calls=t_a_calls+a_calls; t_a_lng=t_a_lng+a_lng; t_a_time=t_a_time+a_time; t_a_estim=t_a_estim+a_estim; t_a_optim=t_a_optim+a_optim;
              datalng = a_lng / a_cnt;
              if      (datalng <  6) {t_a0t_c=t_a0t_c+a_calls; t_a0t_l=t_a0t_l+a_lng; t_a0t_t=t_a0t_t+a_time; t_a0t_e=t_a0t_e+a_estim; t_a0t_o=t_a0t_o+a_optim; }
              else if (datalng <  9) {t_a1w_c=t_a1w_c+a_calls; t_a1w_l=t_a1w_l+a_lng; t_a1w_t=t_a1w_t+a_time; t_a1w_e=t_a1w_e+a_estim; t_a1w_o=t_a1w_o+a_optim; }
              else if (datalng < 15) {t_a1t_c=t_a1t_c+a_calls; t_a1t_l=t_a1t_l+a_lng; t_a1t_t=t_a1t_t+a_time; t_a1t_e=t_a1t_e+a_estim; t_a1t_o=t_a1t_o+a_optim; }
              else if (datalng < 18) {t_a2w_c=t_a2w_c+a_calls; t_a2w_l=t_a2w_l+a_lng; t_a2w_t=t_a2w_t+a_time; t_a2w_e=t_a2w_e+a_estim; t_a2w_o=t_a2w_o+a_optim; }
              else                   {t_a2t_c=t_a2t_c+a_calls; t_a2t_l=t_a2t_l+a_lng; t_a2t_t=t_a2t_t+a_time; t_a2t_e=t_a2t_e+a_estim; t_a2t_o=t_a2t_o+a_optim; }
 
              # exclude badly load balanced calls, i.e., with more thn 4 sec per call
              if (a_time/a_calls > load_bal_treshold) {t_alB_c=t_alB_c+a_calls; t_alB_l=t_alB_l+a_lng; t_alB_t=t_alB_t+a_time; t_alB_e=t_alB_e+a_estim; t_alB_o=t_alB_o+a_optim; } 
              else if (a_lng/a_calls <=       8.5) {t_alA_c=t_alA_c+a_calls; t_alA_l=t_alA_l+a_lng; t_alA_t=t_alA_t+a_time; t_alA_e=t_alA_e+a_estim; t_alA_o=t_alA_o+a_optim; } 
              else if (a_lng/a_calls <=      16.5) {t_al0_c=t_al0_c+a_calls; t_al0_l=t_al0_l+a_lng; t_al0_t=t_al0_t+a_time; t_al0_e=t_al0_e+a_estim; t_al0_o=t_al0_o+a_optim; } 
              else if (a_lng/a_calls <=     128.5) {t_al1_c=t_al1_c+a_calls; t_al1_l=t_al1_l+a_lng; t_al1_t=t_al1_t+a_time; t_al1_e=t_al1_e+a_estim; t_al1_o=t_al1_o+a_optim; } 
              else if (a_lng/a_calls <=    1024.5) {t_al2_c=t_al2_c+a_calls; t_al2_l=t_al2_l+a_lng; t_al2_t=t_al2_t+a_time; t_al2_e=t_al2_e+a_estim; t_al2_o=t_al2_o+a_optim; } 
              else if (a_lng/a_calls <=    2048.5) {t_al3_c=t_al3_c+a_calls; t_al3_l=t_al3_l+a_lng; t_al3_t=t_al3_t+a_time; t_al3_e=t_al3_e+a_estim; t_al3_o=t_al3_o+a_optim; } 
              else if (a_lng/a_calls <=    4096.5) {t_al4_c=t_al4_c+a_calls; t_al4_l=t_al4_l+a_lng; t_al4_t=t_al4_t+a_time; t_al4_e=t_al4_e+a_estim; t_al4_o=t_al4_o+a_optim; } 
              else if (a_lng/a_calls <=    8192.5) {t_al5_c=t_al5_c+a_calls; t_al5_l=t_al5_l+a_lng; t_al5_t=t_al5_t+a_time; t_al5_e=t_al5_e+a_estim; t_al5_o=t_al5_o+a_optim; } 
              else if (a_lng/a_calls <=   32768.5) {t_al6_c=t_al6_c+a_calls; t_al6_l=t_al6_l+a_lng; t_al6_t=t_al6_t+a_time; t_al6_e=t_al6_e+a_estim; t_al6_o=t_al6_o+a_optim; } 
              else if (a_lng/a_calls <=  131072.5) {t_al7_c=t_al7_c+a_calls; t_al7_l=t_al7_l+a_lng; t_al7_t=t_al7_t+a_time; t_al7_e=t_al7_e+a_estim; t_al7_o=t_al7_o+a_optim; } 
              else if (a_lng/a_calls <=  524288.5) {t_al8_c=t_al8_c+a_calls; t_al8_l=t_al8_l+a_lng; t_al8_t=t_al8_t+a_time; t_al8_e=t_al8_e+a_estim; t_al8_o=t_al8_o+a_optim; } 
              else if (a_lng/a_calls <= 2097152.5) {t_al9_c=t_al9_c+a_calls; t_al9_l=t_al9_l+a_lng; t_al9_t=t_al9_t+a_time; t_al9_e=t_al9_e+a_estim; t_al9_o=t_al9_o+a_optim; } 
              else                                 {t_al10_c=t_al10_c+a_calls; t_al10_l=t_al10_l+a_lng; t_al10_t=t_al10_t+a_time; t_al10_e=t_al10_e+a_estim; t_al10_o=t_al10_o+a_optim; } 
 
              if (a_lng/a_calls <=    2048.5) {t_alX1_c=t_alX1_c+a_calls; t_alX1_l=t_alX1_l+a_lng; t_alX1_t=t_alX1_t+a_time; t_alX1_e=t_alX1_e+a_estim; t_alX1_o=t_alX1_o+a_optim; } 
              else                            {t_alX2_c=t_alX2_c+a_calls; t_alX2_l=t_alX2_l+a_lng; t_alX2_t=t_alX2_t+a_time; t_alX2_e=t_alX2_e+a_estim; t_alX2_o=t_alX2_o+a_optim; } 
            } 
          }
        }
      }
    }   
}
END{
  printf(" \n");
  for (size=1; size<=540; size++) if (sum_time[size] != 0)
    printf(" size=%4d, time = %8.2e = %7.0fh = %5.2f%%\n",
             size, sum_time[size],  sum_time[size]/3600,  sum_time[size]/sum_all*100); 
  printf(" \n");
  printf(" Category I = power-of-two number of processes  //  Category II = non-power-of-two\n");
  printf(" \n");
  printf(" Category I:  sum_all1= %8.2e sum_mpi1= %8.2e mpi/all=%6.4f%% \n", sum_all1, sum_mpi1, sum_mpi1 / sum_all1*100); 
  printf(" Category II: sum_all2= %8.2e sum_mpi2= %8.2e mpi/all=%6.4f%% \n", sum_all2, sum_mpi2, sum_mpi2 / sum_all2*100); 
  printf(" Total:       sum_ally= %8.2e sum_mpiy= %8.2e mpi/all=%6.4f%% \n", sum_ally, sum_mpiy, sum_mpiy / sum_ally*100); 
  printf(" Total:       sum_all = %8.2e sum_mpi = %8.2e mpi/all=%6.4f%% \n", sum_all , sum_mpi , sum_mpi  / sum_all *100); 
  printf(" \n");
  printf(" Outside of parenthesis: All %% are percent of total MPI time. (...%%) = percent of total estimated communication time of the routine.\n");
  printf(" \n");
  printf(" Estim.: Estimated communication time without idle-time caused by mis-balanced applications.\n");
  printf("         The estimation is based on the measured number of calls and bytes:\n");
  printf("            estim_time = (calls/latency + bytes/bandwidth) * factor \n");
  printf("         Latency and bandwidth are measured for 2, 4, 8, 16, 32, 64, 128, 256 processes.\n");
  printf("         The factor is based on measurements with different buffer sizes on 32 and 64 processes.\n");
  printf(" \n");
  printf(" Optim.: Estimation based on measurements with the 'chosen best' of the 4 new algorithms.\n");
  printf(" \n");
  printf(" Category I:  %5d jobs, %5d with Reduce, %5d with Allreduce\n",i_jobs,i_rjobs,i_ajobs);
  printf(" \n");
  printf(" Reduce    < 1 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           i_r0x_l,       i_r0x_c,     (i_r0x_c>0 ? i_r0x_l/i_r0x_c : 0), i_r0x_t, i_r0x_t/3600, i_r0x_t/sum_mpi*100, (i_r0x_c>0 ? i_r0x_t/i_r0x_c*1e6 :0), i_r0x_e, i_r0x_e/3600, i_r0x_e/sum_mpi*100, i_r0x_e/t_r_estim*100, i_r0x_o/3600, i_r0x_o/sum_mpi*100, i_r0x_o/t_r_estim*100);  
  printf(" Reduce      1 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%) **\n",
           i_r1w_l,       i_r1w_c,     (i_r1w_c>0 ? i_r1w_l/i_r1w_c : 0), i_r1w_t, i_r1w_t/3600, i_r1w_t/sum_mpi*100, (i_r1w_c>0 ? i_r1w_t/i_r1w_c*1e6 :0), i_r1w_e, i_r1w_e/3600, i_r1w_e/sum_mpi*100, i_r1w_e/t_r_estim*100, i_r1w_o/3600, i_r1w_o/sum_mpi*100, i_r1w_o/t_r_estim*100);  
  printf(" Reduce   1..2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           i_r1x_l,       i_r1x_c,     (i_r1x_c>0 ? i_r1x_l/i_r1x_c : 0), i_r1x_t, i_r1x_t/3600, i_r1x_t/sum_mpi*100, (i_r1x_c>0 ? i_r1x_t/i_r1x_c*1e6 :0), i_r1x_e, i_r1x_e/3600, i_r1x_e/sum_mpi*100, i_r1x_e/t_r_estim*100, i_r1x_o/3600, i_r1x_o/sum_mpi*100, i_r1x_o/t_r_estim*100);  
  printf(" Reduce      2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%) **\n",
           i_r2w_l,       i_r2w_c,     (i_r2w_c>0 ? i_r2w_l/i_r2w_c : 0), i_r2w_t, i_r2w_t/3600, i_r2w_t/sum_mpi*100, (i_r2w_c>0 ? i_r2w_t/i_r2w_c*1e6 :0), i_r2w_e, i_r2w_e/3600, i_r2w_e/sum_mpi*100, i_r2w_e/t_r_estim*100, i_r2w_o/3600, i_r2w_o/sum_mpi*100, i_r2w_o/t_r_estim*100);  
  printf(" Reduce    > 2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           i_r2x_l,       i_r2x_c,     (i_r2x_c>0 ? i_r2x_l/i_r2x_c : 0), i_r2x_t, i_r2x_t/3600, i_r2x_t/sum_mpi*100, (i_r2x_c>0 ? i_r2x_t/i_r2x_c*1e6 :0), i_r2x_e, i_r2x_e/3600, i_r2x_e/sum_mpi*100, i_r2x_e/t_r_estim*100, i_r2x_o/3600, i_r2x_o/sum_mpi*100, i_r2x_o/t_r_estim*100);  
  printf(" \n");
  printf(" Reduce           lng <=    2 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           i_rlX1_l,       i_rlX1_c,     (i_rlX1_c>0 ? i_rlX1_l/i_rlX1_c : 0), i_rlX1_t, i_rlX1_t/3600, i_rlX1_t/sum_mpi*100, (i_rlX1_c>0 ? i_rlX1_t/i_rlX1_c*1e6 :0), i_rlX1_e, i_rlX1_e/3600, i_rlX1_e/sum_mpi*100, i_rlX1_e/t_r_estim*100, i_rlX1_o/3600, i_rlX1_o/sum_mpi*100, i_rlX1_o/t_r_estim*100);  
  printf(" Reduce     2kbb< lng           : %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           i_rlX2_l,       i_rlX2_c,     (i_rlX2_c>0 ? i_rlX2_l/i_rlX2_c : 0), i_rlX2_t, i_rlX2_t/3600, i_rlX2_t/sum_mpi*100, (i_rlX2_c>0 ? i_rlX2_t/i_rlX2_c*1e6 :0), i_rlX2_e, i_rlX2_e/3600, i_rlX2_e/sum_mpi*100, i_rlX2_e/t_r_estim*100, i_rlX2_o/3600, i_rlX2_o/sum_mpi*100, i_rlX2_o/t_r_estim*100);  
  printf(" \n");
  printf(" Category II: %5d jobs, %5d with Reduce, %5d with Allreduce\n",j_jobs,j_rjobs,j_ajobs);
  printf(" \n");
  printf(" Reduce    < 1 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           j_r0x_l,       j_r0x_c,     (j_r0x_c>0 ? j_r0x_l/j_r0x_c : 0), j_r0x_t, j_r0x_t/3600, j_r0x_t/sum_mpi*100, (j_r0x_c>0 ? j_r0x_t/j_r0x_c*1e6 :0), j_r0x_e, j_r0x_e/3600, j_r0x_e/sum_mpi*100, j_r0x_e/t_r_estim*100, j_r0x_o/3600, j_r0x_o/sum_mpi*100, j_r0x_o/t_r_estim*100);  
  printf(" Reduce      1 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%) **\n",
           j_r1w_l,       j_r1w_c,     (j_r1w_c>0 ? j_r1w_l/j_r1w_c : 0), j_r1w_t, j_r1w_t/3600, j_r1w_t/sum_mpi*100, (j_r1w_c>0 ? j_r1w_t/j_r1w_c*1e6 :0), j_r1w_e, j_r1w_e/3600, j_r1w_e/sum_mpi*100, j_r1w_e/t_r_estim*100, j_r1w_o/3600, j_r1w_o/sum_mpi*100, j_r1w_o/t_r_estim*100);  
  printf(" Reduce   1..2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           j_r1x_l,       j_r1x_c,     (j_r1x_c>0 ? j_r1x_l/j_r1x_c : 0), j_r1x_t, j_r1x_t/3600, j_r1x_t/sum_mpi*100, (j_r1x_c>0 ? j_r1x_t/j_r1x_c*1e6 :0), j_r1x_e, j_r1x_e/3600, j_r1x_e/sum_mpi*100, j_r1x_e/t_r_estim*100, j_r1x_o/3600, j_r1x_o/sum_mpi*100, j_r1x_o/t_r_estim*100);  
  printf(" Reduce      2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%) **\n",
           j_r2w_l,       j_r2w_c,     (j_r2w_c>0 ? j_r2w_l/j_r2w_c : 0), j_r2w_t, j_r2w_t/3600, j_r2w_t/sum_mpi*100, (j_r2w_c>0 ? j_r2w_t/j_r2w_c*1e6 :0), j_r2w_e, j_r2w_e/3600, j_r2w_e/sum_mpi*100, j_r2w_e/t_r_estim*100, j_r2w_o/3600, j_r2w_o/sum_mpi*100, j_r2w_o/t_r_estim*100);  
  printf(" Reduce    > 2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           j_r2x_l,       j_r2x_c,     (j_r2x_c>0 ? j_r2x_l/j_r2x_c : 0), j_r2x_t, j_r2x_t/3600, j_r2x_t/sum_mpi*100, (j_r2x_c>0 ? j_r2x_t/j_r2x_c*1e6 :0), j_r2x_e, j_r2x_e/3600, j_r2x_e/sum_mpi*100, j_r2x_e/t_r_estim*100, j_r2x_o/3600, j_r2x_o/sum_mpi*100, j_r2x_o/t_r_estim*100);  
  printf(" \n");
  printf(" Reduce           lng <=    2 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           j_rlX1_l,       j_rlX1_c,     (j_rlX1_c>0 ? j_rlX1_l/j_rlX1_c : 0), j_rlX1_t, j_rlX1_t/3600, j_rlX1_t/sum_mpi*100, (j_rlX1_c>0 ? j_rlX1_t/j_rlX1_c*1e6 :0), j_rlX1_e, j_rlX1_e/3600, j_rlX1_e/sum_mpi*100, j_rlX1_e/t_r_estim*100, j_rlX1_o/3600, j_rlX1_o/sum_mpi*100, j_rlX1_o/t_r_estim*100);  
  printf(" Reduce     2kbb< lng           : %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           j_rlX2_l,       j_rlX2_c,     (j_rlX2_c>0 ? j_rlX2_l/j_rlX2_c : 0), j_rlX2_t, j_rlX2_t/3600, j_rlX2_t/sum_mpi*100, (j_rlX2_c>0 ? j_rlX2_t/j_rlX2_c*1e6 :0), j_rlX2_e, j_rlX2_e/3600, j_rlX2_e/sum_mpi*100, j_rlX2_e/t_r_estim*100, j_rlX2_o/3600, j_rlX2_o/sum_mpi*100, j_rlX2_o/t_r_estim*100);  
  printf(" \n");
  printf(" Total:       %5d jobs, %5d with Reduce, %5d with Allreduce\n",t_jobs,t_rjobs,t_ajobs);
  printf(" \n");
  printf(" Reduce           total:          %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_r_lng,       t_r_calls,     (t_r_calls>0 ? t_r_lng/t_r_calls : 0), t_r_time, t_r_time/3600, t_r_time/sum_mpi*100, (t_r_calls>0 ? t_r_time/t_r_calls*1e6 :0), t_r_estim, t_r_estim/3600, t_r_estim/sum_mpi*100, t_r_estim/t_r_estim*100, t_r_optim/3600, t_r_optim/sum_mpi*100, t_r_optim/t_r_estim*100);  
  printf(" \n");
  printf("------------------------------------------------\n \n");
  printf(" Category I:  %5d jobs, %5d with Reduce, %5d with Allreduce\n",i_jobs,i_rjobs,i_ajobs);
  printf(" \n");
  printf(" Allreduce < 1 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           i_a0x_l,       i_a0x_c,     (i_a0x_c>0 ? i_a0x_l/i_a0x_c : 0), i_a0x_t, i_a0x_t/3600, i_a0x_t/sum_mpi*100, (i_a0x_c>0 ? i_a0x_t/i_a0x_c*1e6 :0), i_a0x_e, i_a0x_e/3600, i_a0x_e/sum_mpi*100, i_a0x_e/t_a_estim*100, i_a0x_o/3600, i_a0x_o/sum_mpi*100, i_a0x_o/t_a_estim*100);  
  printf(" Allreduce   1 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%) **\n",
           i_a1w_l,       i_a1w_c,     (i_a1w_c>0 ? i_a1w_l/i_a1w_c : 0), i_a1w_t, i_a1w_t/3600, i_a1w_t/sum_mpi*100, (i_a1w_c>0 ? i_a1w_t/i_a1w_c*1e6 :0), i_a1w_e, i_a1w_e/3600, i_a1w_e/sum_mpi*100, i_a1w_e/t_a_estim*100, i_a1w_o/3600, i_a1w_o/sum_mpi*100, i_a1w_o/t_a_estim*100);  
  printf(" Allreduce 1-2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           i_a1x_l,       i_a1x_c,     (i_a1x_c>0 ? i_a1x_l/i_a1x_c : 0), i_a1x_t, i_a1x_t/3600, i_a1x_t/sum_mpi*100, (i_a1x_c>0 ? i_a1x_t/i_a1x_c*1e6 :0), i_a1x_e, i_a1x_e/3600, i_a1x_e/sum_mpi*100, i_a1x_e/t_a_estim*100, i_a1x_o/3600, i_a1x_o/sum_mpi*100, i_a1x_o/t_a_estim*100);  
  printf(" Allreduce   2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%) **\n",
           i_a2w_l,       i_a2w_c,     (i_a2w_c>0 ? i_a2w_l/i_a2w_c : 0), i_a2w_t, i_a2w_t/3600, i_a2w_t/sum_mpi*100, (i_a2w_c>0 ? i_a2w_t/i_a2w_c*1e6 :0), i_a2w_e, i_a2w_e/3600, i_a2w_e/sum_mpi*100, i_a2w_e/t_a_estim*100, i_a2w_o/3600, i_a2w_o/sum_mpi*100, i_a2w_o/t_a_estim*100);  
  printf(" Allreduce > 2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           i_a2x_l,       i_a2x_c,     (i_a2x_c>0 ? i_a2x_l/i_a2x_c : 0), i_a2x_t, i_a2x_t/3600, i_a2x_t/sum_mpi*100, (i_a2x_c>0 ? i_a2x_t/i_a2x_c*1e6 :0), i_a2x_e, i_a2x_e/3600, i_a2x_e/sum_mpi*100, i_a2x_e/t_a_estim*100, i_a2x_o/3600, i_a2x_o/sum_mpi*100, i_a2x_o/t_a_estim*100);  
  printf(" \n");
  printf(" Allreduce        lng <=    2 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           i_alX1_l,       i_alX1_c,     (i_alX1_c>0 ? i_alX1_l/i_alX1_c : 0), i_alX1_t, i_alX1_t/3600, i_alX1_t/sum_mpi*100, (i_alX1_c>0 ? i_alX1_t/i_alX1_c*1e6 :0), i_alX1_e, i_alX1_e/3600, i_alX1_e/sum_mpi*100, i_alX1_e/t_a_estim*100, i_alX1_o/3600, i_alX1_o/sum_mpi*100, i_alX1_o/t_a_estim*100);  
  printf(" Allreduce  2kbb< lng           : %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           i_alX2_l,       i_alX2_c,     (i_alX2_c>0 ? i_alX2_l/i_alX2_c : 0), i_alX2_t, i_alX2_t/3600, i_alX2_t/sum_mpi*100, (i_alX2_c>0 ? i_alX2_t/i_alX2_c*1e6 :0), i_alX2_e, i_alX2_e/3600, i_alX2_e/sum_mpi*100, i_alX2_e/t_a_estim*100, i_alX2_o/3600, i_alX2_o/sum_mpi*100, i_alX2_o/t_a_estim*100);  
  printf(" \n");
  printf(" Category II: %5d jobs, %5d with Reduce, %5d with Allreduce\n",j_jobs,j_rjobs,j_ajobs);
  printf(" \n");
  printf(" Allreduce < 1 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           j_a0x_l,       j_a0x_c,     (j_a0x_c>0 ? j_a0x_l/j_a0x_c : 0), j_a0x_t, j_a0x_t/3600, j_a0x_t/sum_mpi*100, (j_a0x_c>0 ? j_a0x_t/j_a0x_c*1e6 :0), j_a0x_e, j_a0x_e/3600, j_a0x_e/sum_mpi*100, j_a0x_e/t_a_estim*100, j_a0x_o/3600, j_a0x_o/sum_mpi*100, j_a0x_o/t_a_estim*100);  
  printf(" Allreduce   1 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%) **\n",
           j_a1w_l,       j_a1w_c,     (j_a1w_c>0 ? j_a1w_l/j_a1w_c : 0), j_a1w_t, j_a1w_t/3600, j_a1w_t/sum_mpi*100, (j_a1w_c>0 ? j_a1w_t/j_a1w_c*1e6 :0), j_a1w_e, j_a1w_e/3600, j_a1w_e/sum_mpi*100, j_a1w_e/t_a_estim*100, j_a1w_o/3600, j_a1w_o/sum_mpi*100, j_a1w_o/t_a_estim*100);  
  printf(" Allreduce 1-2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           j_a1x_l,       j_a1x_c,     (j_a1x_c>0 ? j_a1x_l/j_a1x_c : 0), j_a1x_t, j_a1x_t/3600, j_a1x_t/sum_mpi*100, (j_a1x_c>0 ? j_a1x_t/j_a1x_c*1e6 :0), j_a1x_e, j_a1x_e/3600, j_a1x_e/sum_mpi*100, j_a1x_e/t_a_estim*100, j_a1x_o/3600, j_a1x_o/sum_mpi*100, j_a1x_o/t_a_estim*100);  
  printf(" Allreduce   2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%) **\n",
           j_a2w_l,       j_a2w_c,     (j_a2w_c>0 ? j_a2w_l/j_a2w_c : 0), j_a2w_t, j_a2w_t/3600, j_a2w_t/sum_mpi*100, (j_a2w_c>0 ? j_a2w_t/j_a2w_c*1e6 :0), j_a2w_e, j_a2w_e/3600, j_a2w_e/sum_mpi*100, j_a2w_e/t_a_estim*100, j_a2w_o/3600, j_a2w_o/sum_mpi*100, j_a2w_o/t_a_estim*100);  
  printf(" Allreduce > 2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           j_a2x_l,       j_a2x_c,     (j_a2x_c>0 ? j_a2x_l/j_a2x_c : 0), j_a2x_t, j_a2x_t/3600, j_a2x_t/sum_mpi*100, (j_a2x_c>0 ? j_a2x_t/j_a2x_c*1e6 :0), j_a2x_e, j_a2x_e/3600, j_a2x_e/sum_mpi*100, j_a2x_e/t_a_estim*100, j_a2x_o/3600, j_a2x_o/sum_mpi*100, j_a2x_o/t_a_estim*100);  
  printf(" \n");
  printf(" Allreduce        lng <=    2 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           j_alX1_l,       j_alX1_c,     (j_alX1_c>0 ? j_alX1_l/j_alX1_c : 0), j_alX1_t, j_alX1_t/3600, j_alX1_t/sum_mpi*100, (j_alX1_c>0 ? j_alX1_t/j_alX1_c*1e6 :0), j_alX1_e, j_alX1_e/3600, j_alX1_e/sum_mpi*100, j_alX1_e/t_a_estim*100, j_alX1_o/3600, j_alX1_o/sum_mpi*100, j_alX1_o/t_a_estim*100);  
  printf(" Allreduce  2kbb< lng           : %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           j_alX2_l,       j_alX2_c,     (j_alX2_c>0 ? j_alX2_l/j_alX2_c : 0), j_alX2_t, j_alX2_t/3600, j_alX2_t/sum_mpi*100, (j_alX2_c>0 ? j_alX2_t/j_alX2_c*1e6 :0), j_alX2_e, j_alX2_e/3600, j_alX2_e/sum_mpi*100, j_alX2_e/t_a_estim*100, j_alX2_o/3600, j_alX2_o/sum_mpi*100, j_alX2_o/t_a_estim*100);  
  printf(" \n");
  printf(" Total:       %5d jobs, %5d with Reduce, %5d with Allreduce\n",t_jobs,t_rjobs,t_ajobs);
  printf(" \n");
  printf(" Allreduce        total:          %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_a_lng,       t_a_calls,     (t_a_calls>0 ? t_a_lng/t_a_calls : 0), t_a_time, t_a_time/3600, t_a_time/sum_mpi*100, (t_a_calls>0 ? t_a_time/t_a_calls*1e6 :0), t_a_estim, t_a_estim/3600, t_a_estim/sum_mpi*100, t_a_estim/t_a_estim*100, t_a_optim/3600, t_a_optim/sum_mpi*100, t_a_optim/t_a_estim*100 );  
  printf(" \n");
  printf("===========================================================================================================================================================\n \n");
  printf(" Total:       %5d jobs, %5d with Reduce, %5d with Allreduce\n",t_jobs,t_rjobs,t_ajobs);
  printf(" \n");
  printf(" Reduce    < 1 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_r0x_l,       t_r0x_c,     (t_r0x_c>0 ? t_r0x_l/t_r0x_c : 0), t_r0x_t, t_r0x_t/3600, t_r0x_t/sum_mpi*100, (t_r0x_c>0 ? t_r0x_t/t_r0x_c*1e6 :0), t_r0x_e, t_r0x_e/3600, t_r0x_e/sum_mpi*100, t_r0x_e/t_r_estim*100, t_r0x_o/3600, t_r0x_o/sum_mpi*100, t_r0x_o/t_r_estim*100);  
  printf(" Reduce      1 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%) **\n",
           t_r1w_l,       t_r1w_c,     (t_r1w_c>0 ? t_r1w_l/t_r1w_c : 0), t_r1w_t, t_r1w_t/3600, t_r1w_t/sum_mpi*100, (t_r1w_c>0 ? t_r1w_t/t_r1w_c*1e6 :0), t_r1w_e, t_r1w_e/3600, t_r1w_e/sum_mpi*100, t_r1w_e/t_r_estim*100, t_r1w_o/3600, t_r1w_o/sum_mpi*100, t_r1w_o/t_r_estim*100);  
  printf(" Reduce   1..2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_r1x_l,       t_r1x_c,     (t_r1x_c>0 ? t_r1x_l/t_r1x_c : 0), t_r1x_t, t_r1x_t/3600, t_r1x_t/sum_mpi*100, (t_r1x_c>0 ? t_r1x_t/t_r1x_c*1e6 :0), t_r1x_e, t_r1x_e/3600, t_r1x_e/sum_mpi*100, t_r1x_e/t_r_estim*100, t_r1x_o/3600, t_r1x_o/sum_mpi*100, t_r1x_o/t_r_estim*100);  
  printf(" Reduce      2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%) **\n",
           t_r2w_l,       t_r2w_c,     (t_r2w_c>0 ? t_r2w_l/t_r2w_c : 0), t_r2w_t, t_r2w_t/3600, t_r2w_t/sum_mpi*100, (t_r2w_c>0 ? t_r2w_t/t_r2w_c*1e6 :0), t_r2w_e, t_r2w_e/3600, t_r2w_e/sum_mpi*100, t_r2w_e/t_r_estim*100, t_r2w_o/3600, t_r2w_o/sum_mpi*100, t_r2w_o/t_r_estim*100);  
  printf(" Reduce    > 2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_r2x_l,       t_r2x_c,     (t_r2x_c>0 ? t_r2x_l/t_r2x_c : 0), t_r2x_t, t_r2x_t/3600, t_r2x_t/sum_mpi*100, (t_r2x_c>0 ? t_r2x_t/t_r2x_c*1e6 :0), t_r2x_e, t_r2x_e/3600, t_r2x_e/sum_mpi*100, t_r2x_e/t_r_estim*100, t_r2x_o/3600, t_r2x_o/sum_mpi*100, t_r2x_o/t_r_estim*100);  
  printf(" \n");
  printf(" Reduce    with bad load balance: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_rlB_l,       t_rlB_c,     (t_rlB_c>0 ? t_rlB_l/t_rlB_c : 0), t_rlB_t, t_rlB_t/3600, t_rlB_t/sum_mpi*100, (t_rlB_c>0 ? t_rlB_t/t_rlB_c*1e6 :0), t_rlB_e, t_rlB_e/3600, t_rlB_e/sum_mpi*100, t_rlB_e/t_r_estim*100, t_rlB_o/3600, t_rlB_o/sum_mpi*100, t_rlB_o/t_r_estim*100);  
  printf(" Reduce           lng <=  8 byte: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_rlA_l,       t_rlA_c,     (t_rlA_c>0 ? t_rlA_l/t_rlA_c : 0), t_rlA_t, t_rlA_t/3600, t_rlA_t/sum_mpi*100, (t_rlA_c>0 ? t_rlA_t/t_rlA_c*1e6 :0), t_rlA_e, t_rlA_e/3600, t_rlA_e/sum_mpi*100, t_rlA_e/t_r_estim*100, t_rlA_o/3600, t_rlA_o/sum_mpi*100, t_rlA_o/t_r_estim*100);  
  printf(" Reduce     8 b   lng <= 16 byte: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_rl0_l,       t_rl0_c,     (t_rl0_c>0 ? t_rl0_l/t_rl0_c : 0), t_rl0_t, t_rl0_t/3600, t_rl0_t/sum_mpi*100, (t_rl0_c>0 ? t_rl0_t/t_rl0_c*1e6 :0), t_rl0_e, t_rl0_e/3600, t_rl0_e/sum_mpi*100, t_rl0_e/t_r_estim*100, t_rl0_o/3600, t_rl0_o/sum_mpi*100, t_rl0_o/t_r_estim*100);  
  printf(" Reduce    16 b < lng <=  256 b : %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_rl1_l,       t_rl1_c,     (t_rl1_c>0 ? t_rl1_l/t_rl1_c : 0), t_rl1_t, t_rl1_t/3600, t_rl1_t/sum_mpi*100, (t_rl1_c>0 ? t_rl1_t/t_rl1_c*1e6 :0), t_rl1_e, t_rl1_e/3600, t_rl1_e/sum_mpi*100, t_rl1_e/t_r_estim*100, t_rl1_o/3600, t_rl1_o/sum_mpi*100, t_rl1_o/t_r_estim*100);  
  printf(" Reduce   256 b < lng <=    1 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_rl2_l,       t_rl2_c,     (t_rl2_c>0 ? t_rl2_l/t_rl2_c : 0), t_rl2_t, t_rl2_t/3600, t_rl2_t/sum_mpi*100, (t_rl2_c>0 ? t_rl2_t/t_rl2_c*1e6 :0), t_rl2_e, t_rl2_e/3600, t_rl2_e/sum_mpi*100, t_rl2_e/t_r_estim*100, t_rl2_o/3600, t_rl2_o/sum_mpi*100, t_rl2_o/t_r_estim*100);  
  printf(" Reduce    1 kb < lng <=    2 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_rl3_l,       t_rl3_c,     (t_rl3_c>0 ? t_rl3_l/t_rl3_c : 0), t_rl3_t, t_rl3_t/3600, t_rl3_t/sum_mpi*100, (t_rl3_c>0 ? t_rl3_t/t_rl3_c*1e6 :0), t_rl3_e, t_rl3_e/3600, t_rl3_e/sum_mpi*100, t_rl3_e/t_r_estim*100, t_rl3_o/3600, t_rl3_o/sum_mpi*100, t_rl3_o/t_r_estim*100);  
  printf(" Reduce    2 kb < lng <=    4 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_rl4_l,       t_rl4_c,     (t_rl4_c>0 ? t_rl4_l/t_rl4_c : 0), t_rl4_t, t_rl4_t/3600, t_rl4_t/sum_mpi*100, (t_rl4_c>0 ? t_rl4_t/t_rl4_c*1e6 :0), t_rl4_e, t_rl4_e/3600, t_rl4_e/sum_mpi*100, t_rl4_e/t_r_estim*100, t_rl4_o/3600, t_rl4_o/sum_mpi*100, t_rl4_o/t_r_estim*100);  
  printf(" Reduce    4 kb < lng <=    8 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_rl5_l,       t_rl5_c,     (t_rl5_c>0 ? t_rl5_l/t_rl5_c : 0), t_rl5_t, t_rl5_t/3600, t_rl5_t/sum_mpi*100, (t_rl5_c>0 ? t_rl5_t/t_rl5_c*1e6 :0), t_rl5_e, t_rl5_e/3600, t_rl5_e/sum_mpi*100, t_rl5_e/t_r_estim*100, t_rl5_o/3600, t_rl5_o/sum_mpi*100, t_rl5_o/t_r_estim*100);  
  printf(" Reduce    8 kb < lng <=   32 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_rl6_l,       t_rl6_c,     (t_rl6_c>0 ? t_rl6_l/t_rl6_c : 0), t_rl6_t, t_rl6_t/3600, t_rl6_t/sum_mpi*100, (t_rl6_c>0 ? t_rl6_t/t_rl6_c*1e6 :0), t_rl6_e, t_rl6_e/3600, t_rl6_e/sum_mpi*100, t_rl6_e/t_r_estim*100, t_rl6_o/3600, t_rl6_o/sum_mpi*100, t_rl6_o/t_r_estim*100);  
  printf(" Reduce    32kb < lng <=  128 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_rl7_l,       t_rl7_c,     (t_rl7_c>0 ? t_rl7_l/t_rl7_c : 0), t_rl7_t, t_rl7_t/3600, t_rl7_t/sum_mpi*100, (t_rl7_c>0 ? t_rl7_t/t_rl7_c*1e6 :0), t_rl7_e, t_rl7_e/3600, t_rl7_e/sum_mpi*100, t_rl7_e/t_r_estim*100, t_rl7_o/3600, t_rl7_o/sum_mpi*100, t_rl7_o/t_r_estim*100);  
  printf(" Reduce    128k < lng <=  512 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_rl8_l,       t_rl8_c,     (t_rl8_c>0 ? t_rl8_l/t_rl8_c : 0), t_rl8_t, t_rl8_t/3600, t_rl8_t/sum_mpi*100, (t_rl8_c>0 ? t_rl8_t/t_rl8_c*1e6 :0), t_rl8_e, t_rl8_e/3600, t_rl8_e/sum_mpi*100, t_rl8_e/t_r_estim*100, t_rl8_o/3600, t_rl8_o/sum_mpi*100, t_rl8_o/t_r_estim*100);  
  printf(" Reduce    512k < lng <=    2 MB: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_rl9_l,       t_rl9_c,     (t_rl9_c>0 ? t_rl9_l/t_rl9_c : 0), t_rl9_t, t_rl9_t/3600, t_rl9_t/sum_mpi*100, (t_rl9_c>0 ? t_rl9_t/t_rl9_c*1e6 :0), t_rl9_e, t_rl9_e/3600, t_rl9_e/sum_mpi*100, t_rl9_e/t_r_estim*100, t_rl9_o/3600, t_rl9_o/sum_mpi*100, t_rl9_o/t_r_estim*100);  
  printf(" Reduce    2 MB < lng           : %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_rl10_l,       t_rl10_c,     (t_rl10_c>0 ? t_rl10_l/t_rl10_c : 0), t_rl10_t, t_rl10_t/3600, t_rl10_t/sum_mpi*100, (t_rl10_c>0 ? t_rl10_t/t_rl10_c*1e6 :0), t_rl10_e, t_rl10_e/3600, t_rl10_e/sum_mpi*100, t_rl10_e/t_r_estim*100, t_rl10_o/3600, t_rl10_o/sum_mpi*100, t_rl10_o/t_r_estim*100);  
  printf(" \n");
  printf(" Reduce           lng <=    2 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_rlX1_l,       t_rlX1_c,     (t_rlX1_c>0 ? t_rlX1_l/t_rlX1_c : 0), t_rlX1_t, t_rlX1_t/3600, t_rlX1_t/sum_mpi*100, (t_rlX1_c>0 ? t_rlX1_t/t_rlX1_c*1e6 :0), t_rlX1_e, t_rlX1_e/3600, t_rlX1_e/sum_mpi*100, t_rlX1_e/t_r_estim*100, t_rlX1_o/3600, t_rlX1_o/sum_mpi*100, t_rlX1_o/t_r_estim*100);  
  printf(" Reduce     2kbb< lng           : %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_rlX2_l,       t_rlX2_c,     (t_rlX2_c>0 ? t_rlX2_l/t_rlX2_c : 0), t_rlX2_t, t_rlX2_t/3600, t_rlX2_t/sum_mpi*100, (t_rlX2_c>0 ? t_rlX2_t/t_rlX2_c*1e6 :0), t_rlX2_e, t_rlX2_e/3600, t_rlX2_e/sum_mpi*100, t_rlX2_e/t_r_estim*100, t_rlX2_o/3600, t_rlX2_o/sum_mpi*100, t_rlX2_o/t_r_estim*100);  
  printf(" \n");
  printf(" Reduce           total:          %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_r_lng,       t_r_calls,     (t_r_calls>0 ? t_r_lng/t_r_calls : 0), t_r_time, t_r_time/3600, t_r_time/sum_mpi*100, (t_r_calls>0 ? t_r_time/t_r_calls*1e6 :0), t_r_estim, t_r_estim/3600, t_r_estim/sum_mpi*100, t_r_estim/t_r_estim*100, t_r_optim/3600, t_r_optim/sum_mpi*100, t_r_optim/t_r_estim*100);    
  printf(" Reduce                                                                                                                               Idle:  %8.2e sec =%6.0fh =%5.2f%%\n",
           (t_r_time-t_r_estim), (t_r_time-t_r_estim)/3600, (t_r_time-t_r_estim)/sum_mpi*100);
  printf(" \n");
  printf("------------------------------------------------\n \n");
  printf(" Allreduce < 1 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_a0t_l,       t_a0t_c,     (t_a0t_c>0 ? t_a0t_l/t_a0t_c : 0), t_a0t_t, t_a0t_t/3600, t_a0t_t/sum_mpi*100, (t_a0t_c>0 ? t_a0t_t/t_a0t_c*1e6 :0), t_a0t_e, t_a0t_e/3600, t_a0t_e/sum_mpi*100, t_a0t_e/t_a_estim*100, t_a0t_o/3600, t_a0t_o/sum_mpi*100, t_a0t_o/t_a_estim*100);  
  printf(" Allreduce   1 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%) **\n",
           t_a1w_l,       t_a1w_c,     (t_a1w_c>0 ? t_a1w_l/t_a1w_c : 0), t_a1w_t, t_a1w_t/3600, t_a1w_t/sum_mpi*100, (t_a1w_c>0 ? t_a1w_t/t_a1w_c*1e6 :0), t_a1w_e, t_a1w_e/3600, t_a1w_e/sum_mpi*100, t_a1w_e/t_a_estim*100, t_a1w_o/3600, t_a1w_o/sum_mpi*100, t_a1w_o/t_a_estim*100);  
  printf(" Allreduce 1-2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_a1t_l,       t_a1t_c,     (t_a1t_c>0 ? t_a1t_l/t_a1t_c : 0), t_a1t_t, t_a1t_t/3600, t_a1t_t/sum_mpi*100, (t_a1t_c>0 ? t_a1t_t/t_a1t_c*1e6 :0), t_a1t_e, t_a1t_e/3600, t_a1t_e/sum_mpi*100, t_a1t_e/t_a_estim*100, t_a1t_o/3600, t_a1t_o/sum_mpi*100, t_a1t_o/t_a_estim*100);  
  printf(" Allreduce   2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%) **\n",
           t_a2w_l,       t_a2w_c,     (t_a2w_c>0 ? t_a2w_l/t_a2w_c : 0), t_a2w_t, t_a2w_t/3600, t_a2w_t/sum_mpi*100, (t_a2w_c>0 ? t_a2w_t/t_a2w_c*1e6 :0), t_a2w_e, t_a2w_e/3600, t_a2w_e/sum_mpi*100, t_a2w_e/t_a_estim*100, t_a2w_o/3600, t_a2w_o/sum_mpi*100, t_a2w_o/t_a_estim*100);  
  printf(" Allreduce > 2 words: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_a2t_l,       t_a2t_c,     (t_a2t_c>0 ? t_a2t_l/t_a2t_c : 0), t_a2t_t, t_a2t_t/3600, t_a2t_t/sum_mpi*100, (t_a2t_c>0 ? t_a2t_t/t_a2t_c*1e6 :0), t_a2t_e, t_a2t_e/3600, t_a2t_e/sum_mpi*100, t_a2t_e/t_a_estim*100, t_a2t_o/3600, t_a2t_o/sum_mpi*100, t_a2t_o/t_a_estim*100);  
  printf(" \n");
  printf(" Allreduce with bad load balance: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_alB_l,       t_alB_c,     (t_alB_c>0 ? t_alB_l/t_alB_c : 0), t_alB_t, t_alB_t/3600, t_alB_t/sum_mpi*100, (t_alB_c>0 ? t_alB_t/t_alB_c*1e6 :0), t_alB_e, t_alB_e/3600, t_alB_e/sum_mpi*100, t_alB_e/t_a_estim*100, t_alB_o/3600, t_alB_o/sum_mpi*100, t_alB_o/t_a_estim*100);  
  printf(" Allreduce        lng <=  8 byte: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_alA_l,       t_alA_c,     (t_alA_c>0 ? t_alA_l/t_alA_c : 0), t_alA_t, t_alA_t/3600, t_alA_t/sum_mpi*100, (t_alA_c>0 ? t_alA_t/t_alA_c*1e6 :0), t_alA_e, t_alA_e/3600, t_alA_e/sum_mpi*100, t_alA_e/t_a_estim*100, t_alA_o/3600, t_alA_o/sum_mpi*100, t_alA_o/t_a_estim*100);  
  printf(" Allreduce  8 b   lng <= 16 byte: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_al0_l,       t_al0_c,     (t_al0_c>0 ? t_al0_l/t_al0_c : 0), t_al0_t, t_al0_t/3600, t_al0_t/sum_mpi*100, (t_al0_c>0 ? t_al0_t/t_al0_c*1e6 :0), t_al0_e, t_al0_e/3600, t_al0_e/sum_mpi*100, t_al0_e/t_a_estim*100, t_al0_o/3600, t_al0_o/sum_mpi*100, t_al0_o/t_a_estim*100);  
  printf(" Allreduce 16 b < lng <=  256 b : %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_al1_l,       t_al1_c,     (t_al1_c>0 ? t_al1_l/t_al1_c : 0), t_al1_t, t_al1_t/3600, t_al1_t/sum_mpi*100, (t_al1_c>0 ? t_al1_t/t_al1_c*1e6 :0), t_al1_e, t_al1_e/3600, t_al1_e/sum_mpi*100, t_al1_e/t_a_estim*100, t_al1_o/3600, t_al1_o/sum_mpi*100, t_al1_o/t_a_estim*100);  
  printf(" Allreduce 256b < lng <=    1 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_al2_l,       t_al2_c,     (t_al2_c>0 ? t_al2_l/t_al2_c : 0), t_al2_t, t_al2_t/3600, t_al2_t/sum_mpi*100, (t_al2_c>0 ? t_al2_t/t_al2_c*1e6 :0), t_al2_e, t_al2_e/3600, t_al2_e/sum_mpi*100, t_al2_e/t_a_estim*100, t_al2_o/3600, t_al2_o/sum_mpi*100, t_al2_o/t_a_estim*100);  
  printf(" Allreduce 1 kb < lng <=    2 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_al3_l,       t_al3_c,     (t_al3_c>0 ? t_al3_l/t_al3_c : 0), t_al3_t, t_al3_t/3600, t_al3_t/sum_mpi*100, (t_al3_c>0 ? t_al3_t/t_al3_c*1e6 :0), t_al3_e, t_al3_e/3600, t_al3_e/sum_mpi*100, t_al3_e/t_a_estim*100, t_al3_o/3600, t_al3_o/sum_mpi*100, t_al3_o/t_a_estim*100);  
  printf(" Allreduce 2 kb < lng <=    4 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_al4_l,       t_al4_c,     (t_al4_c>0 ? t_al4_l/t_al4_c : 0), t_al4_t, t_al4_t/3600, t_al4_t/sum_mpi*100, (t_al4_c>0 ? t_al4_t/t_al4_c*1e6 :0), t_al4_e, t_al4_e/3600, t_al4_e/sum_mpi*100, t_al4_e/t_a_estim*100, t_al4_o/3600, t_al4_o/sum_mpi*100, t_al4_o/t_a_estim*100);  
  printf(" Allreduce 4 kb < lng <=    8 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_al5_l,       t_al5_c,     (t_al5_c>0 ? t_al5_l/t_al5_c : 0), t_al5_t, t_al5_t/3600, t_al5_t/sum_mpi*100, (t_al5_c>0 ? t_al5_t/t_al5_c*1e6 :0), t_al5_e, t_al5_e/3600, t_al5_e/sum_mpi*100, t_al5_e/t_a_estim*100, t_al5_o/3600, t_al5_o/sum_mpi*100, t_al5_o/t_a_estim*100);  
  printf(" Allreduce 8 kb < lng <=   32 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_al6_l,       t_al6_c,     (t_al6_c>0 ? t_al6_l/t_al6_c : 0), t_al6_t, t_al6_t/3600, t_al6_t/sum_mpi*100, (t_al6_c>0 ? t_al6_t/t_al6_c*1e6 :0), t_al6_e, t_al6_e/3600, t_al6_e/sum_mpi*100, t_al6_e/t_a_estim*100, t_al6_o/3600, t_al6_o/sum_mpi*100, t_al6_o/t_a_estim*100);  
  printf(" Allreduce 32kb < lng <=  128 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_al7_l,       t_al7_c,     (t_al7_c>0 ? t_al7_l/t_al7_c : 0), t_al7_t, t_al7_t/3600, t_al7_t/sum_mpi*100, (t_al7_c>0 ? t_al7_t/t_al7_c*1e6 :0), t_al7_e, t_al7_e/3600, t_al7_e/sum_mpi*100, t_al7_e/t_a_estim*100, t_al7_o/3600, t_al7_o/sum_mpi*100, t_al7_o/t_a_estim*100);  
  printf(" Allreduce 128k < lng <=  512 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_al8_l,       t_al8_c,     (t_al8_c>0 ? t_al8_l/t_al8_c : 0), t_al8_t, t_al8_t/3600, t_al8_t/sum_mpi*100, (t_al8_c>0 ? t_al8_t/t_al8_c*1e6 :0), t_al8_e, t_al8_e/3600, t_al8_e/sum_mpi*100, t_al8_e/t_a_estim*100, t_al8_o/3600, t_al8_o/sum_mpi*100, t_al8_o/t_a_estim*100);  
  printf(" Allreduce 512k < lng <=    2 MB: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_al9_l,       t_al9_c,     (t_al9_c>0 ? t_al9_l/t_al9_c : 0), t_al9_t, t_al9_t/3600, t_al9_t/sum_mpi*100, (t_al9_c>0 ? t_al9_t/t_al9_c*1e6 :0), t_al9_e, t_al9_e/3600, t_al9_e/sum_mpi*100, t_al9_e/t_a_estim*100, t_al9_o/3600, t_al9_o/sum_mpi*100, t_al9_o/t_a_estim*100);  
  printf(" Allreduce 2 MB < lng           : %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_al10_l,       t_al10_c,     (t_al10_c>0 ? t_al10_l/t_al10_c : 0), t_al10_t, t_al10_t/3600, t_al10_t/sum_mpi*100, (t_al10_c>0 ? t_al10_t/t_al10_c*1e6 :0), t_al10_e, t_al10_e/3600, t_al10_e/sum_mpi*100, t_al10_e/t_a_estim*100, t_al10_o/3600, t_al10_o/sum_mpi*100, t_al10_o/t_a_estim*100);  
  printf(" \n");
  printf(" Allreduce        lng <=    2 kb: %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_alX1_l,       t_alX1_c,     (t_alX1_c>0 ? t_alX1_l/t_alX1_c : 0), t_alX1_t, t_alX1_t/3600, t_alX1_t/sum_mpi*100, (t_alX1_c>0 ? t_alX1_t/t_alX1_c*1e6 :0), t_alX1_e, t_alX1_e/3600, t_alX1_e/sum_mpi*100, t_alX1_e/t_a_estim*100, t_alX1_o/3600, t_alX1_o/sum_mpi*100, t_alX1_o/t_a_estim*100);  
  printf(" Allreduce  2kbb< lng           : %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_alX2_l,       t_alX2_c,     (t_alX2_c>0 ? t_alX2_l/t_alX2_c : 0), t_alX2_t, t_alX2_t/3600, t_alX2_t/sum_mpi*100, (t_alX2_c>0 ? t_alX2_t/t_alX2_c*1e6 :0), t_alX2_e, t_alX2_e/3600, t_alX2_e/sum_mpi*100, t_alX2_e/t_a_estim*100, t_alX2_o/3600, t_alX2_o/sum_mpi*100, t_alX2_o/t_a_estim*100);  
  printf(" \n");
  printf(" Allreduce        total:          %8.2e byte / %8.2e calls = %8.2e byte/call, %8.2e sec =%6.0fh =%5.2f%%, %6.0f us/call. Estim: %8.2e sec =%6.0fh =%5.2f%% (%3.0f%%) Optim: %6.0fh =%5.2f%% (%3.0f%%)\n",
           t_a_lng,       t_a_calls,     (t_a_calls>0 ? t_a_lng/t_a_calls : 0), t_a_time, t_a_time/3600, t_a_time/sum_mpi*100, (t_a_calls>0 ? t_a_time/t_a_calls*1e6 :0), t_a_estim, t_a_estim/3600, t_a_estim/sum_mpi*100, t_a_estim/t_a_estim*100, t_a_optim/3600, t_a_optim/sum_mpi*100, t_a_optim/t_a_estim*100);     
  printf(" Allreduce                                                                                                                            Idle:  %8.2e sec =%6.0fh =%5.2f%%\n",
           (t_a_time-t_a_estim), (t_a_time-t_a_estim)/3600, (t_a_time-t_a_estim)/sum_mpi*100);
  printf(" \n");
  printf(" bad load balancing category is chosen if MPI time per call >%4.1g sec\n", load_bal_treshold);
  printf(" \n");
  printf(" Total:       sum_all = %8.2e sum_mpi = %8.2e mpi/all=%6.4f%% \n", sum_all , sum_mpi , sum_mpi  / sum_all *100); 
  printf(" \n");
  printf("===========================================================================================================================================================\n \n");
  printf(" Summary of Reduce for Exel tables\n");
  printf(" \n");
  printf(" Buffersize              total bytes,   total calls,   estim. communication time  with optimized protocols\n");
  printf(" 'with bad load balance:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_rlB_l, t_rlB_c, t_rlB_e/3600, t_rlB_e/t_r_estim*100, t_rlB_o/3600, t_rlB_o/t_r_estim*100);  
  printf(" '       lng <=  8 byte:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_rlA_l, t_rlA_c, t_rlA_e/3600, t_rlA_e/t_r_estim*100, t_rlA_o/3600, t_rlA_o/t_r_estim*100);  
  printf(" ' 8 b   lng <= 16 byte:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_rl0_l, t_rl0_c, t_rl0_e/3600, t_rl0_e/t_r_estim*100, t_rl0_o/3600, t_rl0_o/t_r_estim*100);  
  printf(" '16 b < lng <=  256 b :' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_rl1_l, t_rl1_c, t_rl1_e/3600, t_rl1_e/t_r_estim*100, t_rl1_o/3600, t_rl1_o/t_r_estim*100);  
  printf(" '256b < lng <=    1 kb:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_rl2_l, t_rl2_c, t_rl2_e/3600, t_rl2_e/t_r_estim*100, t_rl2_o/3600, t_rl2_o/t_r_estim*100);  
  printf(" '1 kb < lng <=    2 kb:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_rl3_l, t_rl3_c, t_rl3_e/3600, t_rl3_e/t_r_estim*100, t_rl3_o/3600, t_rl3_o/t_r_estim*100);  
  printf(" '2 kb < lng <=    4 kb:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_rl4_l, t_rl4_c, t_rl4_e/3600, t_rl4_e/t_r_estim*100, t_rl4_o/3600, t_rl4_o/t_r_estim*100);  
  printf(" '4 kb < lng <=    8 kb:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_rl5_l, t_rl5_c, t_rl5_e/3600, t_rl5_e/t_r_estim*100, t_rl5_o/3600, t_rl5_o/t_r_estim*100);  
  printf(" '8 kb < lng <=   32 kb:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_rl6_l, t_rl6_c, t_rl6_e/3600, t_rl6_e/t_r_estim*100, t_rl6_o/3600, t_rl6_o/t_r_estim*100);  
  printf(" '32kb < lng <=  128 kb:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_rl7_l, t_rl7_c, t_rl7_e/3600, t_rl7_e/t_r_estim*100, t_rl7_o/3600, t_rl7_o/t_r_estim*100);  
  printf(" '128k < lng <=  512 kb:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_rl8_l, t_rl8_c, t_rl8_e/3600, t_rl8_e/t_r_estim*100, t_rl8_o/3600, t_rl8_o/t_r_estim*100);  
  printf(" '512k < lng <=    2 MB:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_rl9_l, t_rl9_c, t_rl9_e/3600, t_rl9_e/t_r_estim*100, t_rl9_o/3600, t_rl9_o/t_r_estim*100);  
  printf(" '2 MB < lng           :' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_rl10_l, t_rl10_c, t_rl10_e/3600, t_rl10_e/t_r_estim*100, t_rl10_o/3600, t_rl10_o/t_r_estim*100);  
  printf(" \n");
  printf(" 'total                :' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_r_lng, t_r_calls, t_r_estim/3600, t_r_estim/t_r_estim*100, t_r_optim/3600, t_r_optim/t_r_estim*100);     
  printf(" \n");
  printf(" Summary of Allreduce for Exel tables\n");
  printf(" \n");
  printf(" Buffersize              total bytes,   total calls,   estim. communication time  with optimized protocols\n");
  printf(" 'with bad load balance:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_alB_l, t_alB_c, t_alB_e/3600, t_alB_e/t_a_estim*100, t_alB_o/3600, t_alB_o/t_a_estim*100);  
  printf(" '       lng <=  8 byte:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_alA_l, t_alA_c, t_alA_e/3600, t_alA_e/t_a_estim*100, t_alA_o/3600, t_alA_o/t_a_estim*100);  
  printf(" ' 8 b   lng <= 16 byte:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_al0_l, t_al0_c, t_al0_e/3600, t_al0_e/t_a_estim*100, t_al0_o/3600, t_al0_o/t_a_estim*100);  
  printf(" '16 b < lng <=  256 b :' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_al1_l, t_al1_c, t_al1_e/3600, t_al1_e/t_a_estim*100, t_al1_o/3600, t_al1_o/t_a_estim*100);  
  printf(" '256b < lng <=    1 kb:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_al2_l, t_al2_c, t_al2_e/3600, t_al2_e/t_a_estim*100, t_al2_o/3600, t_al2_o/t_a_estim*100);  
  printf(" '1 kb < lng <=    2 kb:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_al3_l, t_al3_c, t_al3_e/3600, t_al3_e/t_a_estim*100, t_al3_o/3600, t_al3_o/t_a_estim*100);  
  printf(" '2 kb < lng <=    4 kb:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_al4_l, t_al4_c, t_al4_e/3600, t_al4_e/t_a_estim*100, t_al4_o/3600, t_al4_o/t_a_estim*100);  
  printf(" '4 kb < lng <=    8 kb:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_al5_l, t_al5_c, t_al5_e/3600, t_al5_e/t_a_estim*100, t_al5_o/3600, t_al5_o/t_a_estim*100);  
  printf(" '8 kb < lng <=   32 kb:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_al6_l, t_al6_c, t_al6_e/3600, t_al6_e/t_a_estim*100, t_al6_o/3600, t_al6_o/t_a_estim*100);  
  printf(" '32kb < lng <=  128 kb:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_al7_l, t_al7_c, t_al7_e/3600, t_al7_e/t_a_estim*100, t_al7_o/3600, t_al7_o/t_a_estim*100);  
  printf(" '128k < lng <=  512 kb:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_al8_l, t_al8_c, t_al8_e/3600, t_al8_e/t_a_estim*100, t_al8_o/3600, t_al8_o/t_a_estim*100);  
  printf(" '512k < lng <=    2 MB:' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_al9_l, t_al9_c, t_al9_e/3600, t_al9_e/t_a_estim*100, t_al9_o/3600, t_al9_o/t_a_estim*100);  
  printf(" '2 MB < lng           :' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_al10_l, t_al10_c, t_al10_e/3600, t_al10_e/t_a_estim*100, t_al10_o/3600, t_al10_o/t_a_estim*100);  
  printf(" \n");
  printf(" 'total                :' %8.2e byte, %8.2e calls, Estim: %6.0f h, %6.2f %%, Optim: %6.0f h, %6.2f %%\n",
           t_a_lng, t_a_calls, t_a_estim/3600, t_a_estim/t_a_estim*100, t_a_optim/3600, t_a_optim/t_a_estim*100);     
  printf(" \n");
  printf(" Overview: %6.2f%% of the application time is spent in MPI routines.\n", sum_mpi/sum_all*100);
  printf(" \n");
  printf(" From the MPI time, %6.2f%% is spent in MPI_Allreduce (%6.2f%% in MPI_Reduce),\n", t_a_time/sum_mpi*100, t_r_time/sum_mpi*100);
  printf("               with %6.2f%% used as idle-time         (%6.2f%%) for load balancing the application\n",(t_a_time-t_a_estim)/sum_mpi*100, (t_r_time-t_r_estim)/sum_mpi*100);
  printf("               and  %6.2f%% used for communicating    (%6.2f%%) \n", t_a_estim/sum_mpi*100, t_r_estim/sum_mpi*100);
  printf("                      V____ from this, %6.2f%%        (%6.2f%%) is latency based,\n",   t_alX1_e/t_a_estim*100, t_rlX1_e/t_r_estim*100);
  printf("                            and        %6.2f%%        (%6.2f%%) is bandwidth based.\n", t_alX2_e/t_a_estim*100, t_rlX2_e/t_r_estim*100);
  printf("                            The communcation time can be reduced with the new algorithms by a factor of %6.4f (%6.4f)\n", t_a_optim/t_a_estim, t_r_optim/t_r_estim);
  printf(" \n");
  printf(" The profiling was done on the T3E-900 of the HLRS (www.hlrs.de) with 512 application-PEs, July 1998 - June 2003.\n");
  printf(" The totally profiled application time was %3.1f years of the total system = %4.1f%% of the 5 year profiling period.\n", sum_all/512/3600/24/365, sum_all/512/3600/24/365 / 5 * 100);
  avg_size = sum_size / t_jobs; weighted_avg_size = sum_all / sum_wall_clock;
  printf(" \n");
  printf(" Average: %6.2f PEs per job, and weighted by the application time: %6.2f = (%8.2e/%8.2e) PEs per job\n",
           avg_size, weighted_avg_size, sum_all, sum_wall_clock);
}
